const $rulebtn = document.getElementById('rulebtn');
const $rule = document.getElementById('rule');
const $close = document.getElementById('close');
const $message = document.getElementById('message');
const $gamescreen = document.getElementById('gamescreen');
const $handlist = document.getElementById('handlist');
const $handcard = document.getElementsByClassName('handcard');
const $addcard = document.getElementById('addcard');
const $battle = document.getElementById('battle');

let numAry = []; //数字の配列
let usedNum = [] //使用済みの数字
let cardIndex = 0; //カードのインデックス
let total = 0;
const ranMax = 11;
const ranMin = 1;

function listCreate() {
    const $handcard_li = document.createElement('li');
    $handcard_li.className = 'handcard';
    $handlist.appendChild($handcard_li);

    $handcard[cardIndex].textContent = numAry[cardIndex];
    usedNum.push(numAry[cardIndex]);

    showTotalNumber();
}

function showTotalNumber() {
    total = usedNum.reduce(function(sum, val) {
        return sum + val;
    });
    $gamescreen.textContent = total;
}

function ranNumCreate() {
    numAry = Array.from(new Set(Array(ranMax).fill().map(x => ~~(Math.random() * (ranMax - ranMin + 1) + ranMin))));
    
    //除去後の配列の個数
    let remNum = ranMax - numAry.length;

    if(remNum != 0) {
        for(let remNum; numAry.length < ranMax;) {
            numAry = Array.from(new Set([...numAry, ...Array(remNum).fill().map(x => ~~(Math.random() * (ranMax - ranMin + 1) + ranMin))]));
        }
    }
}

function judge() {
    $message.textContent = "メッセージ";

    if(total === 21) {
        $gamescreen.textContent = "パーフェクト！";
    } else if (total > 15 && total < 21) {
        $gamescreen.textContent = "ゲームクリア！";
    } else {
        $gamescreen.textContent = "次は頑張ろう";
    }

    $gamescreen.style.fontSize = 32 + "px";
}

//カードを追加したときの処理
$addcard.addEventListener('click', () => {
    cardIndex++;

    listCreate();
    
    //手札の枚数が10になった場合、カード追加ボタンを無効化
    if(usedNum.length === ranMax - 1) {
        $addcard.disabled = true;
        $addcard.style.backgroundColor = "#CCCCCC";
    }
});

//勝負するとき
$battle.addEventListener('click', () => {
    cardIndex++;
    listCreate();

    judge();
    
    $addcard.disabled = true;
    $battle.disabled = true;

    $addcard.style.backgroundColor = "#CCCCCC";
    $battle.style.backgroundColor = "#CCCCCC";
});

//ルールボタン
$rulebtn.addEventListener('click', () => {
    $rule.classList.add('active');
});

//クローズボタン
$close.addEventListener('click', () => {
    $rule.classList.remove('active');
});

ranNumCreate();
listCreate();
